//
//  SLTipOverlay.h
//  demos
//
//  Created by  on 12-3-31.
//  Copyright (c) 2012年 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <QuartzCore/QuartzCore.h>

@class SLTipCommand,SLTipOverlay;
@protocol SLTipDelegae <NSObject>

@optional
-(BOOL)tipOverlay:(SLTipOverlay *)tipOverlay ShouldHideWithCommand:(SLTipCommand *)command;
-(void)tipOverlay:(SLTipOverlay *)tipOverlay DidHideWithCommand:(SLTipCommand *)command;
-(BOOL)tipOverlay:(SLTipOverlay *)tipOverlay ShouldClearCommandQueueOnCanceledWithCommand:(SLTipCommand *)command;

@end
@interface SLTipOverlay : UIView{
    UILabel *msgLabel;
    UIButton *closeBtn;
    UIImageView *loadingView;
    SLTipCommand *command;
    BOOL showing;
    NSTimer *hideTimer;
    id<SLTipDelegae> delegate;
    CGPoint showingCenter;
    CGFloat offset;
    NSMutableArray *commandQueue;
    UINavigationController *parentController;
    BOOL isLoading;
    BOOL isContinuous;
}
@property (nonatomic,assign)BOOL isContinuous;
@property (nonatomic,retain)UINavigationController *parentController;
@property (nonatomic,assign)CGFloat offset;
@property (nonatomic,assign)id<SLTipDelegae> delegate;
@property (nonatomic, readonly)SLTipCommand *command;
@property (nonatomic,assign,getter = isShowing) BOOL showing;   
-(void)showCommand:(SLTipCommand *)theCommand;
+(SLTipOverlay *)sharedTipInController:(UINavigationController *)controller;
@end

@interface SLTipCommand : NSObject{
    int tag;
    BOOL closeable;
    CGFloat loadingProcess;
    BOOL autoHide;
    CGFloat duration;
    NSString *msg;
}
@property(nonatomic,assign)BOOL autoHide;
@property(nonatomic,assign)CGFloat duration;
@property(nonatomic,assign)int tag;
@property(nonatomic,assign)BOOL closeable;
@property(nonatomic,readwrite)CGFloat loadingProcess;
@property(nonatomic,copy)NSString *msg;

-(id)initWithMessage:(NSString *)message Closeable:(BOOL)isCloseable LoadingProcess:(CGFloat)process AutoHide:(BOOL)isAutoHide Duration:(CGFloat)hideDuration;
+(SLTipCommand *)tipCommandForMessage:(NSString *)message;
+(SLTipCommand *)tipCommandForLoadingWithMessage:(NSString *)message LoadingProcess:(CGFloat)process;
+(SLTipCommand *)tipCommandForLoadingFinishedWithMessage:(NSString *)message LoadingProcess:(CGFloat)process;
@end